Vue Bootstrap Inputs

Vue Inputs - Bootstrap 4 & Material Design

Note: This documentation is for an older version of Bootstrap (v.4). A newer version is available for Bootstrap 5. We recommend migrating to the latest version of our product - Material Design for Bootstrap 5.
Go to docs v.5

Vue Bootstrap input is a special field which is used in order to receive data from the user. Used mostly in a variety of web-based forms. You can use material design version or default bootstrap style.

Binding value

Vue Input behaves just like a regular input - bind the value with v-model or listen to the input and change events it emits.

Vue live preview

Default input

Default styling for Bootstrap Input component

        
            
          <template>
            <div class="form-group">
              <label for="example1">Default input</label>
              <input type="text" id="example1" class="form-control">
            </div>
          </template>
          
        
    

Material input

Material Design styling for Bootstrap Input component

        
            
          <template>
            <mdb-input label="Material input" v-model="value" />
          </template>
          
        
    
        
            
          <script>
            import {
              mdbInput
            } from 'mdbvue';
            export default {
              name: "Input",
              components: {
                mdbInput
              },
              data() {
                return {
                  value: ''
                };
              }
            }
          </script>
          
        
    

Input sizing

Inputs are provided in 3 sizes: small - sm, medium (default) - md and large - lg. Use prop size to monipualte them.

Default input

        
            
          <template>
            <div>
              <div class="form-group">
                <label for="example1">Large input</label>
                <input type="text" id="example1" class="form-control form-control-lg">
              </div>
              <div class="form-group">
                <label for="example2">Medium input</label>
                <input type="text" id="example2" class="form-control form-control-md">
              </div>
              <div class="form-group">
                <label for="example3">Small input</label>
                <input type="text" id="example3" class="form-control form-control-sm">
              </div>
            </div>
          </template>
          
        
    

Material input

        
            
          <template>
            <div>
              <mdb-input label="Large input" size="lg" />
              <mdb-input label="Medium input" size="md" />
              <mdb-input label="Small input" size="sm" />
            </div>
          </template>
          
        
    
        
            
          <script>
            import {
              mdbInput
            } from 'mdbvue';
            export default {
              name: "Input",
              components: {
                mdbInput
              }
            }
          </script>
          
        
    

Icon prefixes

You can add icons to your inputs. Just use prop icon with icon name.

Default input

        
            
          <template>
            <div class="input-group">
              <div class="input-group-prepend">
                <span class="input-group-text" id="basic-addon">
                        <i class="fas fa-user prefix"></i>
                      </span>
              </div>
              <input type="text" class="form-control" placeholder="Username" aria-label="Username"
                aria-describedby="basic-addon">
            </div>
          </template>
          
        
    

Material input

        
            
          <template>
            <mdb-input label="Username" icon="user" />
          </template>
          
        
    
        
            
          <script>
            import {
              mdbInput
            } from 'mdbvue';
            export default {
              name: "Input",
              components: {
                mdbInput
              }
            }
          </script>
          
        
    

Placeholder

To describe what the input stands for we use labels or placeholders. To set placeholder use it as a prop.

Default input

        
            
          <template>
            <div class="form-group">
              <input type="email" class="form-control" placeholder="Your e-mail" />
            </div>
          </template>
          
        
    

Material input

`
        
            
          <template>
            <mdb-input type="email" placeholder="Your e-mail" />
          </template>
          
        
    
        
            
          <script>
            import {
              mdbInput
            } from 'mdbvue';
            export default {
              name: "Input",
              components: {
                mdbInput
              }
            }
          </script>
          
        
    

Label

Label set up is the same as placeholder's. Jus set appropriate prop label.

Default input

        
            
          <template>
            <div class="form-group">
              <label for="exampleInput">Your e-mail</label>
              <input type="email" id="exampleInput" class="form-control" />
            </div>
          </template>
          
        
    

Material input

        
            
          <template>
            <mdb-input type="email" placeholder="Your e-mail" />
          </template>
          
        
    
        
            
          <script>
            import {
              mdbInput
            } from 'mdbvue';
            export default {
              name: "Input",
              components: {
                mdbInput
              }
            }
          </script>
          
        
    

Disabled

To prevent user interactions add boolean disabled prop.

Default input

        
            
          <template>
            <div class="form-group">
              <label for="exampleDisabled" class="disabled">Disabled input</label>
              <input type="text" id="exampleDisabled" class="form-control" placeholder="Disabled input" disabled>
            </div>
          </template>
          
        
    

Material input

        
            
          <template>
            <mdb-input placeholder="Disabled input" label="Disabled input" disabled />
          </template>
          
        
    
        
            
          <script>
            import {
              mdbInput
            } from 'mdbvue';
            export default {
              name: "Input",
              components: {
                mdbInput
              }
            }
          </script>
          
        
    

Numeric input

Use following example to define a field for entering a number

Default input

        
            
          <template>
            <mdb-input type="number" :min="0" :max="10" v-model="number" outline />
          </template>
          
        
    
        
            
          <script>
            import {
              mdbInput
            } from 'mdbvue';
            export default {
              name: "Input",
              components: {
                mdbInput
              },
              data() {
                return {
                  number: 5
                };
              }
            }
          </script>
          
        
    

Material input

        
            
          <template>
            <mdb-input type="number" v-model="value" />
            <template>
              
        
    
        
            
              <script>
                import {
                  mdbInput
                } from 'mdbvue';
                export default {
                  name: "Input",
                  components: {
                    mdbInput
                  },
                  data() {
                    return {
                      value: 3
                    };
                  }
                }
              </script>
              
        
    

Help text

Block-level help text in forms can be created using .form-text (previously known as .help-block in v3).

Help text below inputs can be styled with .form-text. This class includes display: block and adds some top margin for easy spacing from the inputs above it.

While using material inputs pass a string with a desired text to a small property.

Default input

Your password must be 8-20 characters long, contain letters and numbers, and must not contain spaces, special characters, or emoji.
        
            
            <template>
              <div class="form-group">
                <label for="exampleHelpText">Default input</label>
                <input type="text" id="exampleHelpText" class="form-control" placeholder="Default input">
                <small id="passwordHelpBlock" class="form-text text-muted">
                  Your password must be 8-20 characters long, contain letters and numbers, and must not contain
                  spaces,
                  special characters,
                  or emoji.
                </small>
              </div>
            </template>
            
        
    

Material input

Your password must be 8-20 characters long, contain letters and numbers, and must not contain spaces, special characters, or emoji.
        
            
            <template>
              <mdb-input small="Your password must be 8-20 characters long, contain letters and numbers, and must not contain spaces,
                special characters, or emoji." placeholder="Material input" label="Material input" />
            </template>
            
        
    
        
            
            <script>
              import {
                mdbInput
              } from 'mdbvue';
              export default {
                name: "Input",
                componens: {
                  mdbInput
                }
              }
            </script>
            
        
    

Character counter MDB Pro component

Use a character counter in fields where a character restriction is in place.


Input field

        
            
        <template>
          <mdb-input type="text" label="Input text" counter />
        </template>
        
        
    
        
            
        <script>
          import {
            mdbInput
          } from 'mdbvue';
          export default {
            name: "Input",
            components: {
              mdbInput
            }
          }
        </script>
        
        
    

Outline inputs - Material 2.0

New Material 2.0 styles of inputs


Input field

Default styling for Bootstrap Input component.

        
            
      <template>
        <mdb-input type="text" label="Basic example" outline />
      </template>
      
        
    
        
            
      <script>
        import {
          mdbInput
        } from "mdbvue";
        export default {
          name: "InputsPage",
          components: {
            mdbInput
          }
        };
      </script>
      
        
    

Large outline input

        
            
          <template>
            <mdb-input type="text" size="lg" label="Basic example" outline />
          </template>
          
        
    
        
            
          <script>
            import {
              mdbInput
            } from "mdbvue";
            export default {
              name: "InputsPage",
              components: {
                mdbInput
              }
            };
          </script>
          
        
    

Small outline input

        
            
          <template>
            <mdb-input size="sm" type="text" label="Basic example" outline />
          </template>
          
        
    
        
            
          <script>
            import {
              mdbInput
            } from "mdbvue";
            export default {
              name: "InputsPage",
              components: {
                mdbInput
              }
            };
          </script>
          
        
    

Prefix

We'll never share your email with anyone.
        
            
      <template>
        <mdb-input type="email" label="E-mail address" icon="envelope" small="We'll never share your email with anyone."
          outline />
      </template>
      
        
    
        
            
      <script>
        import {
          mdbInput
        } from "mdbvue";
        export default {
          name: "InputsPage",
          components: {
            mdbInput
          }
        };
      </script>
      
        
    

Disabled

        
            
      <template>
        <mdb-input type="text" label="Disabled input" outline disabled />
      </template>
      
        
    
        
            
      <script>
        import {
          mdbInput
        } from "mdbvue";
        export default {
          name: "InputsPage",
          components: {
            mdbInput
          }
        };
      </script>
      
        
    

Textarea

Textareas allow larger expandable user input. The border should light up simply and clearly indicating which field the user is currently editing.

        
            
      <template>
        <mdb-input type="textarea" label="Outline textarea" outline :rows="3" />
      </template>
      
        
    
        
            
      <script>
        import {
          mdbInput
        } from "mdbvue";
        export default {
          name: "InputsPage",
          components: {
            mdbInput
          }
        };
      </script>
      
        
    

Inputs with background and animated border - Material 2.0

New Material 2.0 styles of inputs


Input field

        
            
      <template>
        <mdb-input type="text" label="Example label" bg />
      </template>
      
        
    
        
            
      <script>
        import {
          mdbInput
        } from "mdbvue";
        export default {
          name: "InputsPage",
          components: {
            mdbInput
          }
        };
      </script>
      
        
    

Large input with background

        
            
          <template>
            <mdb-input type="text" label="Large input" bg size="lg" />
          </template>
          
        
    
        
            
          <script>
            import {
              mdbInput
            } from "mdbvue";
            export default {
              name: "InputsPage",
              components: {
                mdbInput
              }
            };
          </script>
          
        
    

Small input with background

        
            
          <template>
            <mdb-input type="text" label="Small input" bg size="sm" />
          </template>
          
        
    
        
            
          <script>
            import {
              mdbInput
            } from "mdbvue";
            export default {
              name: "InputsPage",
              components: {
                mdbInput
              }
            };
          </script>
          
        
    

A fix for default background color of input in the browser

When you use a browser, sometimes you safe your e-mail address and the password on the page. On any website where you have a form and you safed your data, Chrome is auto-filling the email and password fields and changes the background color to a pale yellow or blue color.

To avoid this default behavior of the browser, you can use a solution below:


Basic solution

In our basic example we want to remove blue background and black text and change to transparent background and grey text.

Here you can find a snippet with working example. It works with outline inputs too.

        
            
      <style>
        @-webkit-keyframes autofill {
          to {
            color: #666;
            background: transparent;
          }
        }

        @keyframes autofill {
          to {
            color: #666;
            background: transparent;
          }
        }

        input:-webkit-autofill {
          -webkit-animation-name: autofill;
          animation-name: autofill;
          -webkit-animation-fill-mode: both;
          animation-fill-mode: both;
        }
      </style>
      
        
    

Note: If you need other background and text colors, don't hesitate to create your own color options. Below, you can see whole white form.

Input - API

In this section you will find advanced information about the Input component. You will learn which modules are required in this component, what are the possibilities of configuring the component, and what events and methods you can use to work with it.


Import statement

        
            
        <script>
          import { mdbInput } from 'mdbvue';
        </script>
        
        
    

API Reference: Properties

Name Type Default Description Example
active Boolean false Focus input when the page loads <mdb-input active ... />
tag String input Component's tag <mdb-input tag="input" />
basic Boolean false Sets default design <mdb-input basic ... />
bg Boolean false Sets design to animated border one with background <mdb-input bg ... />
disabled Boolean false Disables input component <mdb-input disabled ... />
id String The id of the input element. Required <mdb-input required ... />
name String Add name of the input element <mdb-input name="name" ... />
placeholder String Add content to the component placeholder <mdb-input placeholder="Example placeholder" ... />
required Boolean false Determines that the input has to have value <mdb-input required ... />
type String text The input component type atribute <mdb-input type="text" ... />
autofocus Boolean false Focus input when the page loads <mdb-input autofocus ... />
validation Boolean false Enables default validation <mdb-input validation ... />
customValidation Boolean false Enables custom validation <mdb-input customValidation ... />
isValid Boolean false Custom validation check <mdb-input :isValid="true" ... />
validFeedback [String, Boolean] false Valid feedback label <mdb-input validFeedback="Correct" ... />
invalidFeedback [String, Boolean] false Invalid feedback label <mdb-input :invalidFeedback="Incorrect" ... />
outline Boolean Changes material select to outline style <mdb-input outline ... />
small String Adds small text below input <mdb-input small="Must be 8-20 characters long." ... />
size String Determines the size of the input <mdb-input size="lg" />
navInput Boolean false Changes the input's style to nav (without border and shadow box) <mdb-input nav-input />
waves Boolean false Adds waves effect to the input <mdb-input waves />
wrapperClass String Adds classes to the Input's wrapper <mdb-input wrapperClass="customClass" />
noWrapper Boolean false Removes wrapper from the component <mdb-input noWrapper />
inputClass String Adds classes tot the input <mdb-input inputClass="..." />
maxlength String, Number Adds maxlength attribute to the input <mdb-input :maxlength="17" />
readOnly Boolean Adds read-only attribute to the input <mdb-input read-only />
autocomplete String Adds autocomplete attribute to the input <mdb-input autocomplete="..." />
counter Boolean Enables counter <mdb-input counter />
counterMaxValue Number 10 Sets the counter's maximum value <mdb-input counter :counterMaxValue="20" />
icon String Adds icon on the left site of the input <mdb-input icon="envelope" ... />
iconClass String Add a class to the prefix icon <mdb-input iconClass="red-text" />
far String Add the style of the prefix icon to regular <mdb-input icon="..." far />
regular String Add the style of the prefix icon to regular <mdb-input icon="..." regular />
fal String Add the style of the prefix icon to light <mdb-input icon="..." fal />
light String Add the style of the prefix icon to light <mdb-input icon="..." light />
fab String Add the style of the prefix icon to brands <mdb-input icon="..." fab />
brands String Add the style of the prefix icon to brands <mdb-input icon="..." brands />
label String Add description to the component label <mdb-input label="Example label" ... />
labelColor String Changes label's color <mdb-input labelColor="red" />
labelClass String Adds custom class to the label <mdb-input labelClass="red-text" />
min Number Sets minimum value to component with type property set to number <mdb-input type="number" :min="2" ... />
max Number Sets maximum value to component with type property set to number <mdb-input type="number" :max="10" ... />
step Number Sets value of default incrementation (reserved for components with type="number") <mdb-input type="number" :step="0.3" ... />
gap Boolean false Adds gap beetween radio button border and inside circle <mdb-input type="radio" gap />
radioValue String The input's radio value <mdb-input type="radio" radioValue="option1" />
filled Boolean Add filled-in style to checkbox <mdb-input type="checkbox" filled />
checked Boolean false Pre-selects checkbox when the page loads. <mdb-input type="checkbox" checked />
checkboxValue String Sets checkbox value <mdb-input type="checkbox" checkbox-value="..." />
rows Number Sets number of rows in the textarea <mdb-input type="textarea" rows />
ariaLabel String Adds attribute aria-label to the input <mdb-input aria-label="..." />
ariaDescribedBy String Adds attribute aria-described-by to the input <mdb-input aria-described-by="..." />
ariaLabelledBy String Adds attribute aria-labelled-by to the input <mdb-input aria-labelled-by="..." />
ariaMultiselectable Boolean Adds attribute aria-multiselectable to the input <mdb-input aria-multiselectable />
ariaDisabled Boolean Adds attribute aria-disabled to the input <mdb-input aria-disabled />
ariaRequired Boolean Adds attribute aria-required to the input <mdb-input aria-required />
ariaHaspopup Boolean Adds attribute aria-haspopup to the input <mdb-input aria-haspopup />
role String Adds role to the input <mdb-input role="..." />

- property available only for PRO users.


API mdbNumericInput: Properties

We ecourage you to use our default mdb-input with property type="number" - this way you get access to more properties and events.

Name Type Default Description Example
emptyValue Number 0 Default input value <mdb-numeric-input :emptyValue="5" ... />
max Number Maximal input value <mdb-numeric-input :max="10" ... />
min Number Minimal input value <mdb-numeric-input :min="0" ... />
minus Boolean false Applies negative values <mdb-numeric-input minus ... />
placeholder String '' Applies input's placeholder <mdb-numeric-input placeholder="Number" ... />
separator String ',' Input's value separation symbol <mdb-numeric-input separator="." ... />

API Reference: Events

Name Description Example
v-on:input Used to listen to input event, returns Event <mdb-input @input="hanelOnInput" />
v-on:change Emitted on input's native change event, meaning when the field looses focus, but also then the value is changed dynamically. <mdb-input @change="hanelOnChange" />
v-on:focus Emitted on input's native focus event, meaning when the field gains focus. <mdb-input @focus="onFocus" />
v-on:blur Emitted on input's native blur event, meaning when the field looses focus. <mdb-input @blur="onBlur" />

API Reference: Directives

Name Description Example
v-model Vue.js's directive for emulating input element's two-way data binding. It is syntactic sugar for chaining together value prop and input event listener. <mdb-input v-model="inputText" />

Inputs - examples & customization


A form within a card

Sign up

        
            
      <template>
        <mdb-card>
          <mdb-card-body>
            <mdb-card-title class="text-center">Sign up</mdb-card-title>
            <form class="grey-text">
              <mdb-input type="text" @input="handleInput" id="name" label="Your name" icon="user" />
              <mdb-input type="email" @input="handleInput" id="email" label="Your email" icon="envelope" />
              <mdb-input type="email" @input="handleInput" id="confEmail" label="Confirm your email"
                icon="exclamation-triangle" />
              <mdb-input type="password" @input="handleInput" id="passwd" label="Your password" icon="lock" />
            </form>
            <div class="text-center py-4 mt-3">
              <mdb-btn color="cyan">Register</mdb-btn>
            </div>
          </mdb-card-body>
        </mdb-card>
      </template>
      
        
    
        
            
      <script>
        import {
          mdbInput,
          mdbCard,
          mdbCardBody,
          mdbCardTitle,
          mdbBtn
        } from "mdbvue";
        export default {
          name: "CardForm",
          components: {
            mdbBtn,
            mdbCard,
            mdbCardBody,
            mdbCardTitle,
            mdbInput
          },
          methods: {
            handleInput(val) {
              console.log(val);
            }
          }
        }
      </script>

React Bootstrap Inputs

React Inputs - Bootstrap 4 & Material Design

Note: This documentation is for an older version of Bootstrap (v.4). A newer version is available for Bootstrap 5. We recommend migrating to the latest version of our product - Material Design for Bootstrap 5.
Go to docs v.5

React Bootstrap input is a special field which is used in order to receive data from the user. Used mostly in a variety of web-based forms. You can use material design version or default bootstrap style.


Default input

Default styling for Bootstrap Input component

        
            
              import React from "react";

              const InputPage = () => {
                return (
                  <div className="form-group">
                    <label htmlFor="formGroupExampleInput">Default input</label>
                    <input
                      type="text"
                      className="form-control"
                      id="formGroupExampleInput"
                    />
                  </div>
                );
              }

              export default InputPage;
           
        
    

Material input

Material Design styling for Bootstrap Input component

        
              
              import React from "react";
              import { MDBInput } from "mdbreact";

              const InputPage = () => {
                return (
                  <MDBInput label="Material input" />
                );
              }

              export default InputPage;
           
        
    

Input sizing

Inputs are provided in 3 sizes: small - sm, medium (default) - md and large - lg. Use prop size to manipulate them.

Default input

        
            
                import React, { Fragment } from "react";

                const InputPage = () => {
                  return (
                    <Fragment>
                      <div className="form-group">
                        <label htmlFor="example1">Large input</label>
                        <input type="text" id="example1" className="form-control form-control-lg" />
                      </div>
                      <div className="form-group">
                        <label htmlFor="example2">Medium input</label>
                        <input type="text" id="example2" className="form-control form-control-md" />
                      </div>
                      <div className="form-group">
                        <label htmlFor="example3">Small input</label>
                        <input type="text" id="example3" className="form-control form-control-sm" />
                      </div>
                    </Fragment>

                  );
                }

                export default InputPage;
             
        
    

Material input

        
            
              import React from "react";
              import { MDBInput } from "mdbreact";

              const InputPage = () => {
                return (
                  <div className="form-group">
                   <MDBInput label="Large input" size="lg" />
                   <MDBInput label="Medium input" />
                   <MDBInput label="Small input" size="sm" />
                  </div>
                );
              }

              export default InputPage;
           
        
    

Icon prefixes

You can add icons to your inputs. Just use prop icon with icon name.

Default input

        
            
                import React from "react";

                const InputPage = () => {
                  return (
                    <div className="input-group">
                      <div className="input-group-prepend">
                        <span className="input-group-text" id="basic-addon">
                          <i className="fa fa-user prefix"></i>
                        </span>
                      </div>
                      <input type="text" className="form-control" placeholder="Username" aria-label="Username" aria-describedby="basic-addon" />
                    </div>
                  );
                }

                export default InputPage;
             
        
    

Material input

        
              
              import React from "react";
              import { MDBInput } from "mdbreact";

              const InputPage = () => {
                return (
                  <MDBInput label="Username" icon="user" />
                );
              }

              export default InputPage;
           
        
    

Icon method

You can use icons method to run functions. Just use prop onIconClick, onIconMouseEnter or onIconMouseLeave

        
              
              import React from "react";
              import { MDBInput } from "mdbreact";

              const InputPage = () => {
                return (
                  <MDBInput
                    label="Run function on click icon"
                    icon="bell"
                    onIconClick={() => alert("Wait! This is an alert!")}
                  />
                );
              }

              export default InputPage;
           
        
    

Placeholder

To describe what the input stands for we use labels or placeholders. To set placeholder use hint prop.

Default input

        
            
                import React from "react";

                const InputPage = () => {
                  return (
                    <div className="form-group">
                      <input type="email" className="form-control" placeholder="Your e-mail" />
                    </div>
                  );
                }

                export default InputPage;
             
        
    

Material input

        
              
              import React from "react";
              import { MDBInput } from "mdbreact";

              const InputPage = () => {
                return (
                  <MDBInput hint="Your e-mail" type="email" />
                );
              }

              export default InputPage;
           
        
    

Input number

Enter a number within certain range with the mouse or keyboard.

Default input

        
            

          import React, { Component } from "react";
          import "./index.css";
          
          class inputPage extends Component {
            state = {
              value: 0,
            };
          
            decrease = () => {
              this.setState({ value: this.state.value - 1 });
            };
          
            increase = () => {
              this.setState({ value: this.state.value + 1 });
            };
          
            render() {
              return (
                <div className="def-number-input number-input">
                  <button onClick={this.decrease} className="minus"></button>
                  <input
                    className="quantity"
                    name="quantity"
                    value={this.state.value}
                    onChange={() => console.log("change")}
                    type="number"
                  />
                  <button onClick={this.increase} className="plus"></button>
                </div>
              );
            }
          }
          
          export default inputPage;
            
        
    
        
            

            .number-input input[type="number"] {
              -webkit-appearance: textfield;
              -moz-appearance: textfield;
              appearance: textfield;
            }
            .number-input input[type="number"]::-webkit-inner-spin-button,
            .number-input input[type="number"]::-webkit-outer-spin-button {
              -webkit-appearance: none;
            }
            .number-input {
              margin-bottom: 3rem;
            }
            .number-input button {
              -webkit-appearance: none;
              background-color: transparent;
              border: none;
              align-items: center;
              justify-content: center;
              cursor: pointer;
              margin: 0;
              position: relative;
            }
            .number-input button:before,
            .number-input button:after {
              display: inline-block;
              position: absolute;
              content: "";
              height: 2px;
              transform: translate(-50%, -50%);
            }
            .number-input button.plus:after {
              transform: translate(-50%, -50%) rotate(90deg);
            }
            .number-input input[type="number"] {
              text-align: center;
            }
            .number-input.number-input {
              border: 1px solid #ced4da;
              width: 10rem;
              border-radius: 0.25rem;
            }
            .number-input.number-input button {
              width: 2.6rem;
              height: 0.7rem;
            }
            .number-input.number-input button.minus {
              padding-left: 10px;
            }
            .number-input.number-input button:before,
            .number-input.number-input button:after {
              width: 0.7rem;
              background-color: #495057;
            }
            .number-input.number-input input[type="number"] {
              max-width: 4rem;
              padding: 0.5rem;
              border: 1px solid #ced4da;
              border-width: 0 1px;
              font-size: 1rem;
              height: 2rem;
              color: #495057;
            }
            

              
        
    

Material input

        
            
          import React from "react";
          import { MDBInput } from 'mdbreact';

          const SelectPage = () => {
            return (
              <MDBInput type="number" />
            );
          }

          export default SelectPage;
        
        
    

Label

Label set up is the same as placeholder's. Jus set appropriate prop label.

Default input

        
            
                import React from "react";

                const InputPage = () => {
                  return (
                    <div className="form-group">
                      <label htmlFor="exampleInput">Your e-mail</label>
                      <input type="email" id="exampleInput" className="form-control" />
                    </div>
                  );
                }

                export default InputPage;
             
        
    

Material input

        
              
              import React from "react";
              import { MDBInput } from "mdbreact";

              const InputPage = () => {
                return (
                  <MDBInput label="Your e-mail" type="email" />
                );
              }

              export default InputPage;
           
        
    

Disabled

To prevent user interaqctions add boolean disabled prop.

Default input

        
            
                import React from "react";

                const InputPage = () => {
                  return (
                    <div className="form-group">
                      <label htmlFor="exampleDisabled" className="disabled">Disabled input</label>
                      <input type="text" id="exampleDisabled" className="form-control" placeholder="Disabled input" disabled />
                    </div>
                  );
                }

                export default InputPage;
             
        
    

Material input

        
              
              import React from "react";
              import { MDBInput } from "mdbreact";

              const InputPage = () => {
                return (
                  <MDBInput label="Disabled input" hint="Disabled input" disabled type="email" />
                );
              }

              export default InputPage;
           
        
    

Outline inputs - Material 2.0

New Material 2.0 styles of inputs


Input field

        
             
          import React from "react";
          import { MDBInput } from "mdbreact";

          const InputPage = () => {
            return (
              <MDBInput label="Example label" outline />
            );
          }

          export default InputPage;
        
        
    

Large outline input

        
             
            import React from "react";
            import { MDBInput } from "mdbreact";

            const InputPage = () => {
              return (
                <MDBInput label="Example label" outline size="lg" />
              );
            }

            export default InputPage;
           
        
    

Small outline input

        
              
            import React from "react";
            import { MDBInput } from "mdbreact";

            const InputPage = () => {
              return (
                <MDBInput label="Example label" outline size="sm" />
              );
            }

            export default InputPage;
           
        
    

Prefix

        
               
        import React from "react";
        import { MDBInput } from "mdbreact";

        const InputPage = () => {
          return (
            <MDBInput label="E-mail address" outline icon="envelope" />
          );
        }

        export default InputPage;
        
        
    

Disabled

        
               
        import React from "react";
        import { MDBInput } from "mdbreact";

        const InputPage = () => {
          return (
            <MDBInput label="Example label" outline disabled />
          );
        }

        export default InputPage;
        
        
    

Textarea

        
               
        import React from "react";
        import { MDBInput } from "mdbreact";

        const InputPage = () => {
          return (
            <MDBInput type="textarea" label="Example label" outline />
          );
        }

        export default InputPage;
        
        
    

Inputs with background and animated border - Material 2.0

New Material 2.0 styles of inputs


Input field

        
               
        import React from "react";
        import { MDBInput } from "mdbreact";

        const InputPage = () => {
          return (
            <MDBInput label="Example label" background />
          );
        }

        export default InputPage;
        
        
    

Large background input

        
              
            import React from "react";
            import { MDBInput } from "mdbreact";

            const InputPage = () => {
              return (
                <MDBInput label="Example label" background size="lg" />
              );
            }

            export default InputPage;
           
        
    

Small background input

        
              
            import React from "react";
            import { MDBInput } from "mdbreact";

            const InputPage = () => {
              return (
                <MDBInput label="Example label" background size="sm" />
              );
            }

            export default InputPage;
           
        
    

Prefix

        
               
        import React from "react";
        import { MDBInput } from "mdbreact";

        const InputPage = () => {
          return (
            <MDBInput label="E-mail address" background icon="envelope" />
          );
        }

        export default InputPage;
        
        
    

Disabled

        
               
        import React from "react";
        import { MDBInput } from "mdbreact";

        const InputPage = () => {
          return (
            <MDBInput label="Example label" background disabled />
          );
        }

        export default InputPage;
        
        
    

Textarea

        
               
        import React from "react";
        import { MDBInput } from "mdbreact";

        const InputPage = () => {
          return (
            <MDBInput type="textarea" label="Example label" background />
          );
        }

        export default InputPage;
        
        
    

React Input - API

In this section you will find advanced information about the React Input component. You will learn which modules are required in this component, what are the possibilities of configuring the component, and what events and methods you can use to work with it.


Import statement

        
            
          import React from 'react';
          import { MDBInput } from 'mdbreact';
        
        
    

API Reference: Properties

The table below shows the configuration options of the MDBInput component.

Name Type Default Description Example
background Boolean false Sets material 2.0 background input mode (input with background and animated border). <MDBInput background />
checked Boolean false Pre-selects checkbox/radio button when the page loads. <MDBInput checked />
className String Adds custom class to Input component <MDBInput className="myClass" />
containerClass String Adds custom class to wrapping div <MDBInput containerClass="wrapper" />
counter Number, Boolean false Renders input with counter element. <MDBInput counter /> <MDBInput counter={15} />
disabled Boolean false Disables input component <MDBInput disabled />
error String Sets the error message for the labels data-error attribute <MDBInput error="Whoops!" />
filled Boolean false Add filled-in style to checkbox/radio button <MDBInput type="checkbox" filled />
gap Boolean false Creates gap inside checkbox/radio button <MDBInput type="checkbox" gap />
group Boolean false Add .form-group class to the wrapping div <MDBInput group />
hint String Sets the placeholder for the Input <MDBInput hint="Placeholder" />
icon String Adds font-awesome icon <MDBInput icon="caret-right" />
iconBrand Boolean false Use this property to set brand icon (fab) <MDBInput icon="twitter" iconBrand />
iconClass String Adds custom classes to icon element <MDBInput icon="envelope" iconClass="customClass" />
iconLight Boolean false Use this property to set light icon (fal) <MDBInput icon="twitter" iconLight />
iconRegular Boolean false Use this property to set regular icon (far) <MDBInput icon="twitter" iconRegular />
iconSize String Sets icon size <MDBInput icon="pencil-alt" iconSize="5x" />
id String Required! Set the id of the input element <MDBInput id="myId" />
inputRef Function Allows to attach React Ref to the input component; accepts only Callback Ref <MDBInput inputRef={ref => this.myRef = ref } />
outline Boolean false Sets material 2.0 outline input mode (input with outline and animated label). <MDBInput outline />
label String Add label to the component; you can attach jsx elements (f.e. links) <MDBInput label="My custom input" />
labelClass String Adds custom class to the label <MDBInput labelClass="labelCustomClass" />
labelId String Sets custom id to the label <MDBInput labelId="myId" />
size String Changes size of the component; available lg and sm <MDBInput size="sm" />
success String Sets the success message for the labels data-success attribute <MDBInput success="Yeah!" />
tag String input Changes default input tag <MDBInput tag="div" />
type String text The type of the input element <MDBInput type="checkbox" />
validate Boolean false Adds .validate class to the Input component <MDBInput validate />
value String The value of the input element (use with the controlled input) <MDBInput value="I am controlled" onChange={this.handleChange} />
valueDefault String The default value of the input (use with the uncontrolled input) <MDBInput valueDefault="I am uncontrolled" />

- property available only for PRO users.

Input also accepts all attributes mentioned here (if not overwritten by prop).


API Reference: Methods

The table below shows the methods which you can use with MDBInput component.

Name Parameters Description Example
getValue Method called on input change event; returns input value <MDBInput getValue={this.getValue} />
onBlur Method called on blur event, the blur event is raised when an element loses focus; returns event object <MDBInput onBlur={this.handleBlur} />
onChange Method called on change event; returns event object <MDBInput onChange={this.handleChange} />
onFocus Method called on focus event, the focus event is raised when the user sets focus on en element; returns event object <MDBInput onFocus={this.handleFocus} />
onIconClick The method called when on mouse click the icon <MDBInput onIconClick={this.clickIcon} />
onIconMouseEnter The method called when on mouse enter the icon <MDBInput onInput={this.mouseEnterIcon} />
onIconMouseLeave The method called when on mouse leave the icon <MDBInput onInput={this.mouseLeaveIcon} />
onInput Method called on input event; returns event object <MDBInput onInput={this.handleInput} />

React Input - examples & customization

Quickly get a project started with any of our examples.


A form within a card

Sign up

        
            
        import React, { Component } from "react";
        import { MDBCol, MDBInput, MDBBtn, MDBCard, MDBCardBody } from "mdbreact";
        
        class TextareaPage extends Component {
          constructor() {
            super();
            this.state = {
              name: "",
              email: "",
              message: ""
            };
          } 
        
          handleInput = e => {
            this.setState({
              [e.target.name]: e.target.value
            })
          }
        
          sendForm = () => {
            fetch('https://some/url', {
              method: 'POST',
              body: JSON.stringify({
                name: this.state.name,
                email: this.state.email,
                message: this.state.message
              })
            })
            .then(res => res.json())
            .catch(err => console.log(err));
          }
        
          render() {
            return (
              <MDBCol md="4">
                <MDBCard>
                  <MDBCardBody>
                    <form>
                      <p className="h4 text-center py-4">Sign up</p>
                      <div className="grey-text">
                        <MDBInput
                          label="Your name"
                          icon="user"
                          group
                          type="text"
                          validate
                          error="wrong"
                          success="right"
                          name="name"
                          value={this.state.name}
                          onInput={this.handleInput}
                        />
                        <MDBInput
                          label="Your email"
                          icon="envelope"
                          group
                          type="email"
                          validate
                          error="wrong"
                          success="right"
                          name="email"
                          value={this.state.email}
                          onInput={this.handleInput}
                        />
                        <MDBInput 
                          type="textarea" 
                          rows="2" 
                          label="Your message" 
                          icon="pencil" 
                          name="message" 
                          value={this.state.message} 
                          onInput={this.handleInput}/>
                      </div>
                      <div className="text-center py-4 mt-3">
                        <MDBBtn color="cyan" onClick={this.sendForm}>
                          Send Message
                        </MDBBtn>
                      </div>
                    </form>
                  </MDBCardBody>
                </MDBCard>
              </MDBCol>
            );
          }
        }
        
        export default TextareaPage;

Angular Bootstrap Inputs

Angular Inputs - Bootstrap 4 & Material Design

Note: This documentation is for an older version of Bootstrap (v.4). A newer version is available for Bootstrap 5. We recommend migrating to the latest version of our product - Material Design for Bootstrap 5.
Go to docs v.5

Angular Bootstrap inputs are special types of fields that are used in order to receive data from the user. Used mostly in a variety of web-based forms.

All of them are created in our beautiful, material design style.

MDB Angular supports the following types of inputs: button, checkbox, email, file, hidden, number, password, radio, range, reset, search, submit, tel, text, and textarea.


Examples

Input field

        
            
          <div class="md-form">
            <input mdbInput type="text" id="form1" class="form-control">
            <label for="form1" class="">Example label</label>
          </div>
        
        
    

Two-way data binding

Look at me:

        
            
          <div class="md-form">
            <input mdbInput type="text" name="text" [(ngModel)]="text" id="form1" class="form-control">
            <label for="form1" class="">Example label</label>
            <p>Look at me! {{text}}</p>
          </div>
        
        
    
        
            
          import { Component } from '@angular/core';

          @Component({
            selector: 'two-way-component',
            templateUrl: './two-way.component.html',
            styleUrls: ['./two-way.component.scss']
          })
          export class TwoWayComponent {
            text = '';
          }
        
        
    

Small input

        
            
          <div class="md-form form-sm">
            <input mdbInput type="text" id="form1" class="form-control form-control-sm">
            <label for="form1" class="">Example label</label>
          </div>
        
        
    

Icon Prefixes

        
            
          <div class="md-form">
            <mdb-icon fas icon="envelope" class="prefix"></mdb-icon>
            <input mdbInput type="text" id="form2" class="form-control">
            <label for="form2">Example label</label>
          </div>
        
        
    

Placeholder

        
            
          <div class="md-form">
            <input mdbInput placeholder="Placeholder" type="text" id="form58" class="form-control">
            <label for="form58">Example label</label>
          </div>
        
        
    

Prefilling Text Inputs

        
            
          <div class="md-form">
            <input value="John Doe" type="text" id="form6" class="form-control" mdbInput>
            <label for="form6">Example label</label>
          </div>
        
        
    

Error or Success Messages

Note that minLength, maxLength defines the minimum and maximum input length. Also data-error, data-success provides space to enter your custom error or success message.

We can now use [errorMessage] and [successMessage] inputs to add custom messages as strings or to pass variables defined in your typescript file. Those inputs will only work when data-error and data-success attributes are not available.

If you do not want to use validation, use [mdbValidation]="false" on the input element, which should not display the validation status. You can use [validateSuccess]="false" or [validateError]="false" to disable only one type of message.

        
            
          <form [formGroup]="validationForm">
            <div class="md-form">
              <mdb-icon fas icon="envelope" class="prefix"></mdb-icon>
              <input mdbInput mdbValidate formControlName="emailFormEx" minLength="8" maxLength="25" type="email"
                     class="form-control" id="form9">
              <label for="form9">Type your e-mail</label>
              <mdb-error *ngIf="emailFormEx.invalid && (emailFormEx.dirty || emailFormEx.touched)">Input invalid</mdb-error>
              <mdb-success *ngIf="emailFormEx.valid && (emailFormEx.dirty || emailFormEx.touched)">Input valid</mdb-success>
            </div>
            <div class="md-form">
              <mdb-icon fas icon="lock" class="prefix"></mdb-icon>
              <input mdbInput mdbValidate formControlName="passwordFormEx" minLength="10" maxLength="25" type="password"
                     class="form-control" id="form10">
              <label for="form10">Type your password</label>
              <mdb-error *ngIf="passwordFormEx.invalid && (passwordFormEx.dirty || passwordFormEx.touched)">Input invalid
              </mdb-error>
              <mdb-success *ngIf="passwordFormEx.valid && (passwordFormEx.dirty || passwordFormEx.touched)">Input valid
              </mdb-success>
            </div>
          </form>
        
        
    
        
            
          import { FormControl, Validators, FormBuilder } from '@angular/forms';
          import { Component } from '@angular/core';

          @Component({
            selector: 'error-success-message',
            templateUrl: './error-success-message.component.html',
            styleUrls: ['./error-success-message.component.scss'],
          })
          export class ErrorSuccessMessageComponent {
            validationForm: FormGroup;

            constructor(public fb: FormBuilder) {
              this.validationForm = fb.group({
                emailFormEx: [null, [Validators.required, Validators.email]],
                passwordFormEx: [null, Validators.required],
              });
            }

            get emailFormEx() { return this.validationForm.get('emailFormEx'); }
            get passwordFormEx() { return this.validationForm.get('passwordFormEx'); }
          }
        
        
    

Disabled input

Add the disabled boolean attribute on an input to prevent user interactions.

To use not-allowed cursor, add .disabled class to the label.

        
            
          <div class="md-form form-sm">
            <input type="text" id="form11" class="form-control" disabled>
            <label for="form11" class="disabled">Example label</label>
          </div>
        
        
    

Form layouts

Since Bootstrap applies both display: block and width: 100% to almost all our form controls, forms will by default stack vertically. Additional classes can be used to vary this layout on a per-form basis.

Form groups

The .form-group class is the easiest way to add some structure to forms. It provides a flexible class that encourages proper grouping of labels, controls, optional help text, and form validation messaging. By default, it only applies margin-bottom, but it picks up additional styles in .form-inline as needed. Use it with <fieldset>s, <div>s, or nearly any other element.

        
            
              <!-- Material form group -->
              <form>
                <!-- Material input -->
                <div class="md-form form-group mt-5">
                  <input mdbInput type="text" class="form-control" id="formGroupExampleInputMD" placeholder="Example input">
                  <label for="formGroupExampleInputMD">Example label</label>
                </div>
                <!-- Material input -->
                <div class="md-form form-group mt-5">
                  <input mdbInput type="text" class="form-control" id="formGroupExampleInput2MD" placeholder="Another input">
                  <label for="formGroupExampleInput2MD">Another label</label>
                </div>
              </form>
              <!-- Material form group -->
            
        
    

Form grid

More complex forms can be built using our grid classes. Use these for form layouts that require multiple columns, varied widths, and additional alignment options.

        
            
              <!-- Material form grid -->
              <form>
                <!-- Grid row -->
                <div class="row">
                  <!-- Grid column -->
                  <div class="col">
                    <!-- Material input -->
                    <div class="md-form mt-0">
                      <input mdbInput type="text" class="form-control" placeholder="First name">
                    </div>
                  </div>
                  <!-- Grid column -->
                  <!-- Grid column -->
                  <div class="col">
                    <!-- Material input -->
                    <div class="md-form mt-0">
                      <input mdbInput type="text" class="form-control" placeholder="Last name">
                    </div>
                  </div>
                  <!-- Grid column -->
                </div>
                <!-- Grid row -->
              </form>
              <!-- Material form grid -->
            
        
    

Form row

You may also swap .row for .form-row, a variation of our standard grid row that overrides the default column gutters for tighter and more compact layouts.

        
            
          <!-- Material form row -->
          <form>
            <!-- Grid row -->
            <div class="form-row">
              <!-- Grid column -->
              <div class="col">
                <!-- Material input -->
                <div class="md-form mt-0">
                  <input type="text" class="form-control" placeholder="First name">
                </div>
              </div>
              <!-- Grid column -->
              <!-- Grid column -->
              <div class="col">
                <!-- Material input -->
                <div class="md-form mt-0">
                  <input type="text" class="form-control" placeholder="Last name">
                </div>
              </div>
              <!-- Grid column -->
            </div>
            <!-- Grid row -->
          </form>
          <!-- Material form row -->
        
        
    
        
            
          <!-- Default form row -->
          <form>
            <!-- Grd row -->
            <div class="form-row">
              <!-- Grid column -->
              <div class="col">
                <!-- Default input -->
                <input mdbInput type="text" class="form-control" placeholder="First name">
              </div>
              <!-- Grid column -->
              <!-- Grid column -->
              <div class="col">
                <!-- Default input -->
                <input mdbInput type="text" class="form-control" placeholder="Last name">
              </div>
              <!-- Grid column -->
            </div>
            <!-- Grd row -->
          </form>
          <!-- Default form row -->
        
        
    

More complex layouts can also be created with the grid system.

        
            
          <!-- Extended material form grid -->
          <form>
            <!-- Grid row -->
            <div class="form-row">
              <!-- Grid column -->
              <div class="col-md-6">
                <!-- Material input -->
                <div class="md-form form-group">
                  <input mdbInput type="email" class="form-control" id="inputEmail4MD" placeholder="Email">
                  <label for="inputEmail4MD">Email</label>
                </div>
              </div>
              <!-- Grid column -->
              <!-- Grid column -->
              <div class="col-md-6">
                <!-- Material input -->
                <div class="md-form form-group">
                  <input mdbInput type="password" class="form-control" id="inputPassword4MD" placeholder="Password">
                  <label for="inputPassword4MD">Password</label>
                </div>
              </div>
              <!-- Grid column -->
            </div>
            <!-- Grid row -->
            <!-- Grid row -->
            <div class="row">
              <!-- Grid column -->
              <div class="col-md-12">
                <!-- Material input -->
                <div class="md-form form-group">
                  <input mdbInput type="text" class="form-control" id="inputAddressMD" placeholder="1234 Main St">
                  <label for="inputAddressMD">Address</label>
                </div>
              </div>
              <!-- Grid column -->
              <!-- Grid column -->
              <div class="col-md-12">
                <!-- Material input -->
                <div class="md-form form-group">
                  <input mdbInput type="text" class="form-control" id="inputAddress2MD" placeholder="Apartment, studio, or floor">
                  <label for="inputAddress2MD">Address 2</label>
                </div>
              </div>
              <!-- Grid column -->
            </div>
            <!-- Grid row -->
            <!-- Grid row -->
            <div class="form-row">
              <!-- Grid column -->
              <div class="col-md-6">
                <!-- Material input -->
                <div class="md-form form-group">
                  <input mdbInput type="text" class="form-control" id="inputCityMD" placeholder="New York City">
                  <label for="inputCityMD">City</label>
                </div>
              </div>
              <!-- Grid column -->
              <!-- Grid column -->
              <div class="col-md-6">
                <!-- Material input -->
                <div class="md-form form-group">
                  <input mdbInput type="text" class="form-control" id="inputZipMD" placeholder="11206-1117">
                  <label for="inputZipMD">Zip</label>
                </div>
              </div>
              <!-- Grid column -->
            </div>
            <!-- Grid row -->
            <button type="submit" mdbBtn color="primary">Sign in</button>
          </form>
          <!-- Extended material form grid -->
        
        
    
        
            
          <!-- Extended default form grid -->
          <form>
            <!-- Grid row -->
            <div class="form-row">
              <!-- Default input -->
              <div class="form-group col-md-6">
                <input mdbInput type="email" class="form-control" id="inputEmail4" placeholder="Email">
                <label for="inputEmail4">Email</label>
              </div>
              <!-- Default input -->
              <div class="form-group col-md-6">
                <input mdbInput type="password" class="form-control" id="inputPassword4" placeholder="Password">
                <label for="inputPassword4">Password</label>
              </div>
            </div>
            <!-- Grid row -->
            <!-- Default input -->
            <div class="form-group">
              <input mdbInput type="text" class="form-control" id="inputAddress" placeholder="1234 Main St">
              <label for="inputAddress">Address</label>
            </div>
            <!-- Default input -->
            <div class="form-group">
              <input mdbInput type="text" class="form-control" id="inputAddress2" placeholder="Apartment, studio, or floor">
              <label for="inputAddress2">Address 2</label>
            </div>
            <!-- Grid row -->
            <div class="form-row">
              <!-- Default input -->
              <div class="form-group col-md-6">
                <input mdbInput type="text" class="form-control" id="inputCity" placeholder="New York City">
                <label for="inputCity">City</label>
              </div>
              <!-- Default input -->
              <div class="form-group col-md-6">
                <input mdbInput type="text" class="form-control" id="inputZip" placeholder="11206-1117">
                <label for="inputZip">Zip</label>
              </div>
            </div>
            <!-- Grid row -->
            <button type="submit" mdbBtn color="primary">Sign in</button>
          </form>
          <!-- Extended default form grid -->
        
        
    

Horizontal form

You can create horizontal forms with the grid by adding the .row class to form groups and using the .col-*-* classes to specify the width of your labels and controls. When doing this, be sure to add .col-form-label to your <label>s as well so they’re vertically centered with their associated form controls.

At times, you maybe need to use margin or padding utilities to create that perfect alignment you desire. For example, we’ve removed the padding-top on our stacked radio inputs label to better align the text baseline.

        
            
          <!-- Horizontal material form -->
          <form>
            <!-- Grid row -->
            <div class="form-group row">
              <!-- Material input -->
              <label for="inputEmail3MD" class="col-sm-2 col-form-label">Email</label>
              <div class="col-sm-10">
                <div class="md-form mt-0">
                  <input mdbInput type="email" class="form-control" id="inputEmail3MD" placeholder="Email">
                </div>
              </div>
            </div>
            <!-- Grid row -->
            <!-- Grid row -->
            <div class="form-group row">
              <!-- Material input -->
              <label for="inputPassword3MD" class="col-sm-2 col-form-label">Password</label>
              <div class="col-sm-10">
                <div class="md-form mt-0">
                  <input mdbInput type="password" class="form-control" id="inputPassword3MD" placeholder="Password">
                </div>
              </div>
            </div>
            <!-- Grid row -->
            <!-- Grid row -->
            <div class="form-group row">
              <div class="col-sm-10">
                <button type="submit" mdbBtn color="primary">Sign in</button>
              </div>
            </div>
            <!-- Grid row -->
          </form>
          <!-- Horizontal material form -->
        
        
    
        
            
          <!-- Default horizontal form -->
          <form>
            <!-- Grid row -->
            <div class="form-group row">
              <!-- Default input -->
              <label for="inputEmail3" class="col-sm-2 col-form-label">Email</label>
              <div class="col-sm-10">
                <input mdbInput type="email" class="form-control" id="inputEmail3" placeholder="Email">
              </div>
            </div>
            <!-- Grid row -->
            <!-- Grid row -->
            <div class="form-group row">
              <!-- Default input -->
              <label for="inputPassword3" class="col-sm-2 col-form-label">Password</label>
              <div class="col-sm-10">
                <input mdbInput type="password" class="form-control" id="inputPassword3" placeholder="Password">
              </div>
            </div>
            <!-- Grid row -->
            <!-- Grid row -->
            <div class="form-group row">
              <div class="col-sm-10">
                <button type="submit" mdbBtn color="primary">Sign in</button>
              </div>
            </div>
            <!-- Grid row -->
          </form>
          <!-- Default horizontal form -->
        
        
    

Column sizing

As shown in the previous examples, our grid system allows you to place any number of .cols within a .row or .form-row. They’ll split the available width equally between them. You may also pick a subset of your columns to take up more or less space, while the remaining .cols equally split the rest, with specific column classes like .col-7.

        
            
          <!-- Material column sizing form -->
          <form>
            <!-- Grid row -->
            <div class="form-row">
              <!-- Grid column -->
              <div class="col-7">
                <!-- Material input -->
                <div class="md-form">
                  <input mdbInput type="text" class="form-control" placeholder="City">
                </div>
              </div>
              <!-- Grid column -->
              <!-- Grid column -->
              <div class="col">
                <!-- Material input -->
                <div class="md-form">
                  <input mdbInput type="text" class="form-control" placeholder="State">
                </div>
              </div>
              <!-- Grid column -->
              <!-- Grid column -->
              <div class="col">
                <!-- Material input -->
                <div class="md-form">
                  <input mdbInput type="text" class="form-control" placeholder="Zip">
                </div>
              </div>
              <!-- Grid column -->
            </div>
            <!-- Grid row -->
          </form>
          <!-- Material column sizing form -->
        
        
    
        
            
          <!-- Default column sizing form -->
          <form>
            <!-- Grid row -->
            <div class="form-row">
              <!-- Grid column -->
              <div class="col-7">
                <!-- Default input -->
                <input mdbInput type="text" class="form-control" placeholder="City">
              </div>
              <!-- Grid column -->
              <!-- Grid column -->
              <div class="col">
                <!-- Default input -->
                <input mdbInput type="text" class="form-control" placeholder="State">
              </div>
              <!-- Grid column -->
              <!-- Grid column -->
              <div class="col">
                <!-- Default input -->
                <input mdbInput type="text" class="form-control" placeholder="Zip">
              </div>
              <!-- Grid column -->
            </div>
            <!-- Grid row -->
          </form>
          <!-- Default column sizing form -->
        
        
    

Auto-sizing

The example below uses a flexbox utility to vertically center the contents and changes .col to .col-auto so that your columns only take up as much space as needed. Put another way, the column sizes itself based on the contents.

@
        
            
          <!-- Material auto-sizing form -->
          <form>
            <!-- Grid row -->
            <div class="form-row align-items-center">
              <!-- Grid column -->
              <div class="col-auto">
                <!-- Material input -->
                <div class="md-form">
                  <input mdbInput type="text" class="form-control mb-2" id="inlineFormInputMD" placeholder="Jane Doe">
                  <label class="sr-only" for="inlineFormInputMD">Name</label>
                </div>
              </div>
              <!-- Grid column -->
              <!-- Grid column -->
              <div class="col-auto">
                <!-- Material input -->
                <label class="sr-only" for="inlineFormInputGroupMD">Username</label>
                <div class="md-form input-group mb-3">
                  <div class="input-group-prepend">
                    <span class="input-group-text md-addon">@</span>
                  </div>
                  <input mdbInput type="text" class="form-control pl-0 rounded-0" id="inlineFormInputGroupMD" placeholder="Username">
                </div>
              </div>
              <!-- Grid column -->
              <!-- Grid column -->
              <div class="col-auto">
                <button type="submit" mdbBtn color="primary" class="mb-0">Submit</button>
              </div>
              <!-- Grid column -->
            </div>
            <!-- Grid row -->
          </form>
          <!-- Material auto-sizing form -->
        
        
    
@
        
            
          <!-- Default auto-sizing form -->
          <form>
            <!-- Grid row -->
            <div class="form-row align-items-center">
              <!-- Grid column -->
              <div class="col-auto">
                <!-- Default input -->
                <label class="sr-only" for="inlineFormInput">Name</label>
                <input mdbInput type="text" class="form-control mb-2" id="inlineFormInput" placeholder="Jane Doe">
              </div>
              <!-- Grid column -->
              <!-- Grid column -->
              <div class="col-auto">
                <!-- Default input -->
                <label class="sr-only" for="inlineFormInputGroup">Username</label>
                <div class="input-group mb-2">
                  <div class="input-group-prepend">
                    <div class="input-group-text">@</div>
                  </div>
                  <input mdbInput type="text" class="form-control py-0" id="inlineFormInputGroup" placeholder="Username">
                </div>
              </div>
              <!-- Grid column -->
              <!-- Grid column -->
              <div class="col-auto">
                <button type="submit" mdbBtn color="primary" class="mt-0">Submit</button>
              </div>
            </div>
            <!-- Grid row -->
          </form>
          <!-- Default auto-sizing form -->
        
        
    

Inline forms

Use can usethe .form-inline class to display a series of labels, form controls, and buttons on a single horizontal row. Form controls within inline forms vary slightly from their default states.

  • The controls are display: flex, collapsing any HTML white space and allowing you to provide alignment control with spacing and flexbox utilities.
  • Controls and input groups receive width: auto to override the Bootstrap default width: 100%.
  • Controls only appear inline in viewports that are at least 576px wide to account for narrow viewports on mobile devices.

You may need to manually address the width and alignment of individual form controls with spacing utilities (as shown below). Lastly, be sure to always include a <label> with each form control, even if you need to hide it from non-screenreader visitors with .sr-only.

@
Remember me
        
            
          <!-- Material inline form -->
          <form class="form-inline">
            <!-- Material input -->
            <div class="md-form">
              <input mdbInput type="text" class="form-control mb-2 mr-sm-2" id="inlineFormInputName2MD" placeholder="Jane Doe">
              <label class="sr-only" for="inlineFormInputName2MD">Name</label>
            </div>
            <!-- Material input -->
            <label class="sr-only" for="inlineFormInputGroupUsername2MD">Username</label>
            <div class="md-form input-group mb-3">
              <div class="input-group-prepend">
                <span class="input-group-text md-addon">@</span>
              </div>
              <input mdbInput type="text" class="form-control pl-0 rounded-0" id="inlineFormInputGroupUsername2MD" placeholder="Username">
            </div>
            <!-- Checkbox -->
            <mdb-checkbox mdbInput class="mb-2 mr-sm-2">Remember me</mdb-checkbox>
            <button type="submit" mdbBtn color="primary" class="mb-0">Submit</button>
          </form>
          <!-- Material inline form -->
        
        
    
@
Remember me
        
            
          <!-- Default inline form -->
          <form class="form-inline">
            <!-- Default input -->
            <label class="sr-only" for="inlineFormInputName2">Name</label>
            <input mdbInput type="text" class="form-control mb-2 mr-sm-2" id="inlineFormInputName2" placeholder="Jane Doe">
            <!-- Default input -->
            <label class="sr-only" for="inlineFormInputGroupUsername2">Username</label>
            <div class="input-group mb-2 mr-sm-2">
              <div class="input-group-prepend">
                <div class="input-group-text">@</div>
              </div>
              <input mdbInput type="text" class="form-control py-0" id="inlineFormInputGroupUsername2" placeholder="Username">
            </div>
            <!-- Checkbox -->
            <mdb-checkbox mdbInput class="mb-2 mr-sm-2">Remember me</mdb-checkbox>
            <button type="submit" mdbBtn color="primary" class="mt-0">Submit</button>
          </form>
          <!-- Default inline form -->
        
        
    

Numeric input

Press the Shift key and then the Arrow Up / Arrow Down key to change the input value by + 10 / - 10.

Press the Alt key and then the Arrow Up / Arrow Down key to change the input value by + 0.1 / - 0.1.

The above functionality is possible by adding the mdbInput to the input element.

        
            
          <div class="md-form">
            <input type="number" class="form-control" id="numberInputEx" mdbInput>
            <label for="numberInputEx">Number input</label>
          </div>
        
        
    

Character counter MDB Pro component

Use a character counter in fields where a character restriction is in place.

Input field

        
            
          <div class="md-form">
            <input id="input_text" class="form-control" type="text" length="10" mdbCharCounter mdbInput>
            <label for="input_text">Input text</label>
          </div>
        
        
    

Textarea

        
            
          <div class="md-form">
            <textarea class="md-textarea form-control " rows="3" id="input_text" type="text" length="120" mdbCharCounter mdbInput></textarea>
            <label for="input_text">Type your text</label>
          </div>
        
        
    

Outline inputs - Material 2.0

New Material 2.0 styles of inputs


Input field

        
            
          <!-- Material outline input -->
          <div class="md-form md-outline">
            <input type="text" id="form1" class="form-control" mdbInput>
            <label for="form1">Example label</label>
          </div>
        
        
    

Large outline input

        
            
              <!-- Large outline input -->
              <div class="md-form md-outline form-lg">
                <input id="form-lg" class="form-control form-control-lg" type="text" mdbInput>
                <label for="form-lg">Example label</label>
              </div>
            
        
    

Small outline input

        
            
              <!-- Small outline input -->
              <div class="md-form md-outline form-sm">
                <input id="form-sm" class="form-control form-control-sm" type="text" mdbInput>
                <label for="form-sm">Example label</label>
              </div>
            
        
    

Prefix

We'll never share your email with anyone.
        
            
          <div class="md-form md-outline">
            <mdb-icon fas icon="envelope"></mdb-icon>
            <input type="text" id="inputIconEx1" class="form-control" mdbInput>
            <label for="inputIconEx1">E-mail address</label>
            <small id="emailHelp2" class="form-text text-muted">We'll never share your email with anyone.</small>
          </div>
        
        
    

Character counter

        
            
          <!-- Material outline counter input -->
          <div class="md-form md-outline">
            <input id="input-char-counter1" type="text" length="10" class="form-control" mdbCharCounter mdbInput>
            <label for="input-char-counter1">Input text</label>
          </div>
        
        
    

Disabled

        
            
          <!-- Material outline disabled input -->
          <div class="md-form md-outline">
            <input type="text" id="inputDisabledEx13" class="form-control" disabled mdbInput>
            <label for="inputDisabledEx13" class="disabled">Example label</label>
          </div>
        
        
    

Validation

        
            
              <!-- Outline validation input -->
              <div class="md-form md-outline">
                <input mdbInput mdbValidate name="email" type="email" id="form8" class="form-control" [(ngModel)]="email" #input="ngModel" required pattern="[^ @]*@[^ @]*">
                <label for="form2">Email validator</label>
                <mdb-error *ngIf="input.invalid && (input.dirty || input.touched)">Input invalid</mdb-error>
                <mdb-success *ngIf="input.valid && (input.dirty || input.touched)">Input valid</mdb-success>
              </div>
            
        
    
        
            
              <!-- Outline validation input -->
              <div class="md-form md-outline">
                <input mdbInput mdbValidate name="input2" type="password" id="form2" class="form-control" [(ngModel)]="minLength" #input2="ngModel" required minlength="3">
                <label for="form2">password validator</label>
                <mdb-error *ngIf="input2.invalid && (input2.dirty || input2.touched)">Input invalid</mdb-error>
                <mdb-success *ngIf="input2.valid && (input2.dirty || input2.touched)">Input valid</mdb-success>
              </div>
            
        
    

Textarea

        
            
          <!--Material textarea-->
          <div class="md-form md-outline">
            <textarea type="text" id="form75" class="form-control md-textarea" rows="3" mdbInput></textarea>
            <label for="form75">Material textarea</label>
          </div>
        
        
    

Inputs with background and animated border - Material 2.0

New Material 2.0 styles of inputs


Input field

        
            
          <!-- Material background input -->
          <div class="md-form md-bg">
            <input type="text" id="formBg1" class="form-control" mdbInput>
            <label for="formBg1">Example label</label>
          </div>
        
        
    

Large input with background

        
            
              <!-- Large background input -->
              <div class="md-form md-bg form-lg">
                <input id="form-bg-lg" class="form-control form-control-lg" type="text" mdbInput>
                <label for="form-bg-lg">Example label</label>
              </div>
            
        
    

Small input with background

        
            
              <!-- Small background input -->
              <div class="md-form md-bg form-sm">
                <input id="form-bg-sm" class="form-control form-control-sm" type="text" mdbInput>
                <label for="form-bg-sm">Example label</label>
              </div>
            
        
    

A fix for the default background color of input in the browser

When you use a browser, sometimes you save your e-mail address and the password on the page. On any website where you have a form and you saved your data, Chrome is auto-filling the email and password fields and changes the background color to a pale yellow or blue color.

To avoid this default behavior of the browser, you can use the solution below:


Basic solution

In our basic example, we want to remove the blue background and black text and change it to a transparent background and grey text.

Here you can find a snippet with a working example. It works with outline inputs too.

        
            
          @-webkit-keyframes autofill {
            to {
              color: #666;
              background: transparent;
            }
          }
          @keyframes autofill {
            to {
              color: #666;
              background: transparent;
            }
          }
          input:-webkit-autofill {
            -webkit-animation-name: autofill;
            animation-name: autofill;
            -webkit-animation-fill-mode: both;
            animation-fill-mode: both;
          }
          .md-form > input[type]:-webkit-autofill:not(.browser-default):not([type='search']) + label {
            transform: translateY(-14px);
          }
        
        
    

Angular Inputs - API

In this section you will find informations about required modules and available inputs, outputs, methods and events of inputs components.


Modules used

In order to speed up your application, you can choose to import only the modules you actually need, instead of importing the entire MDB Angular library. Remember that importing the entire library, and immediately afterwards a specific module, is bad practice, and can cause application errors.

API Reference for MDB Angular Inputs:
        
            
          import { InputsModule, WavesModule, ButtonsModule } from 'ng-uikit-pro-standard';
          import { CharCounterModule } from 'ng-uikit-pro-standard';
        
        
    
        
            
          import { InputsModule, WavesModule, ButtonsModule } from 'angular-bootstrap-md';